//
//  EDAMSharedNotebookHTTPClient.h
//  EverNote
//
//  Created by Andrew McGeachie on 10/15/10.
//  Copyright 2010 Evernote. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "EDAMHTTPClient.h"

@interface EDAMSharedNotebookHTTPClient : EDAMHTTPClient {
  NSString * _shareKey;
  NSString * _shareShard;
  EDAMAuthenticationResult *  _sharedAuthResult;
  NSDate *  _sharedAuthReceivedAt;
  BOOL _businessAccount;
}

- (id) initWithPrimaryClient:(EDAMHTTPClient *)primaryClient
                    shareKey:(NSString *)shareKey
                  shareShard:(NSString *)shareShard
                noteStoreURL:(NSURL *)noteStoreURL;

/**
 * Share key for authenticating with the shared notebook
 */
@property (strong, nonatomic) NSString * shareKey;


/**
 * The shard where the shared notebook is located
 */
@property (strong, nonatomic) NSString * shareShard;


/**
 * Get the EDAMUser object for the owner of this shared ntoebook.
 */
- (EDAMUser *) shareOwnerEDAMUser;


/**
 * Time we received our shared notebook EDAMAuthenticationResult
 */
@property ( strong, nonatomic) NSDate * sharedAuthReceivedAt;


/**
 * The EDAMAuthenticationResult for our shared notebook
 */
@property ( strong, nonatomic) EDAMAuthenticationResult * sharedAuthResult;


@property (assign, nonatomic, getter=isBusinessAccount) BOOL businessAccount;

@end
