//
//  ENBatchCacheDownloadOp.h
//  CoreNote
//
//  Created by Steve White on 6/5/12.
//  Copyright (c) 2012 Evernote Corporation. All rights reserved.
//

#import <Foundation/Foundation.h>

@class EDAMHTTPClient;
@class ENAccountContext;
@class ENNoteMO;
@class ENResourceMO;

extern NSString * const ENBatchCacheDownloadOpErrorDomain;
extern NSString * const ENBatchCacheDownloadOpObjectIDKey;
extern NSString * const ENBatchCacheDownloadOpGUIDKey;
extern NSString * const ENBatchCacheDownloadOpBackingFileKey;
extern NSString * const ENBatchCacheDownloadOpHasTransformerKey;
extern NSString * const ENBatchCacheDownloadOpDataHashKey;

@interface ENBatchCacheDownloadOp : NSOperation {
  ENAccountContext * _accountContext;
  NSMutableDictionary *_resources;
  NSMutableDictionary *_notes;
  uint32_t _totalRequestSize;
  
  void (^_receivedDataBlock)(NSData *);
  uint32_t _bytesReceived;
  NSArray * _errors;
}

@property ( strong, nonatomic) ENAccountContext *accountContext;
@property (strong, nonatomic) EDAMHTTPClient *edamClient;
@property (strong, nonatomic) NSString *notebookGUID;

@property (readonly, nonatomic) uint32_t totalRequestSize;
@property (readonly, nonatomic) uint32_t numberOfRequests;

@property (copy, nonatomic) void (^receivedDataBlock)(NSData *);
@property (strong, nonatomic, readonly) NSArray *errors;
@property (nonatomic, readonly) uint32_t bytesReceived;

// Background processing

@property (nonatomic, assign, getter = isBackground) BOOL background;

- (void) addResource:(ENResourceMO *)resource;
- (void) addNote:(ENNoteMO *)note;

@end
