//
//  ENBytesToHumanReadableSize.h
//  EverNote
//
//  Created by Steve White on 5/20/08.
//  Copyright 2008 Evernote Corporation. All rights reserved.
//

#ifndef ENBytesToHumanReadableSize_HEADER_GUARD
#define ENBytesToHumanReadableSize_HEADER_GUARD


#import <Foundation/Foundation.h>


@interface ENBytesToHumanReadableSize : NSValueTransformer {
  BOOL mNoDecimals;
}

+ (Class)transformedValueClass;
+ (BOOL)allowsReverseTransformation;
- (id)transformedValue:(id)value;


/**
 * This method does the actual work.  Available as a class method
 * for things that don't need a transformer instance.
 */
+ (NSString *) transformUnsignedLongLong: (unsigned long long) size;


/**
 * This method does the actual work.  Available as a class method
 * for things that don't need a transformer instance.
 */
+ (NSString *) transformUnsignedLongLong: (unsigned long long) size
                             withDecimal: (BOOL) withDecimal;


@end

#endif
