//
//  ENCacheDownloadOperation.h
//  CoreNote
//
//  Created by Steve White on 5/23/12.
//  Copyright (c) 2012 Evernote Corporation. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface ENCacheDownloadOperation : NSOperation {
  NSURL * _url;
  NSURLConnection *_connection;
  NSError * _error;
  NSString * _title;
  
  uint32_t _bytesReceived;
  
  BOOL _executing;
  BOOL _finished;
  
  void (^_receivedDataBlock)(NSData *);
}

@property (nonatomic, readonly) NSError *error;
@property (nonatomic, readonly) NSURL *url;
@property (strong, nonatomic) NSString *title;
@property (nonatomic, readonly) uint32_t bytesReceived;
@property (copy, nonatomic) void (^receivedDataBlock)(NSData *);

+ (ENCacheDownloadOperation *) downloadOperationWithURL:(NSURL *)url;

- (id)initWithURL:(NSURL*)url;

@end
