//
//  ENContentTransformer.h
//  MacCoreNote
//
//  Created by Steve White on 10/27/12.
//  Copyright (c) 2012 Evernote Corporation. All rights reserved.
//

#ifndef ENContentTransformer_HEADER_GUARD
#define ENContentTransformer_HEADER_GUARD

#import <Foundation/Foundation.h>

@class ENCoreDataLocalStore;

@protocol ENContentTransformer <NSObject>

@required

- (void) setLocalStore:(ENCoreDataLocalStore *)localStore;

// Typically this would be an ENResourceMOID, so that
// the transformer can use it and the localStore to
// retrieve back an ENResourceMO object
- (void) setObjectID:(id)objectID;

// Transform server content to local content
// Return YES on success, NO on failure
- (BOOL) transformContentsOfFile:(NSString *)file error:(NSError **)error;

// Transform local content to server content
// Return YES on success, NO on failure
- (BOOL) reverseTransformContentsToFile:(NSString *)file error:(NSError **)error;

@end

#endif
