//
//  ENEmailOperation.h
//  MacCoreNote
//
//  Created by Steve White on 6/16/12.
//  Copyright (c) 2012 Evernote Corporation. All rights reserved.
//

#import "ENSyncOperation.h"

@class ENNoteMO;
@class EDAMNote;

@protocol ENMailOperationEDAMNoteGenerator <NSObject>

- (EDAMNote *) generateEDAMNoteFromContentInfo:(id)contentInfo;

@end

@interface ENMailOperationContent : NSObject <NSCoding>

@property (strong, nonatomic) Class edamNoteGeneratorClass;
@property (strong, nonatomic) id contentInfo;

- (EDAMNote *) generateEDAMNote;

@end

@interface ENEmailOperation : ENSyncOperation

+ (ENEmailOperation *) emailOperationForNote:(ENNoteMO *)note;
+ (ENEmailOperation *) emailOperationForContent:(ENMailOperationContent *)emailContent;

@property (strong, nonatomic) NSURL *noteURL;
@property (strong, nonatomic) NSString *notebookGUID;
@property (strong, nonatomic) NSArray *recipients;
@property (strong, nonatomic) NSArray *ccRecipients;
@property (strong, nonatomic) NSString *subject;
@property (strong, nonatomic) NSString *body;
@property (strong, nonatomic) ENMailOperationContent *emailContent;
@property (nonatomic) BOOL sendFromBusinessShard;

@end
