//
//  ENMetadataStore.h
//  Evernote
//
//  Created by Steve White on 6/19/12.
//  Copyright (c) 2012 Evernote Corporation. All rights reserved.
//

#ifndef ENMetadataStore_HEADER_GUARD
#define ENMetadataStore_HEADER_GUARD

#import <Foundation/Foundation.h>

@class ENManagedObject;

@protocol ENMetadataStore <NSObject>

- (NSDictionary *) metadataForServiceEntity:(ENManagedObject *)serviceEntity;
- (id) objectForKey:(NSString *)key;
- (NSEnumerator *)keyEnumerator;
- (void) setObject:(id)object forKey:(NSString *)key;
- (void) setMetadata:(NSDictionary*)metadata forServiceEntity:(ENManagedObject*)serviceEntity;
- (void) removeMetadataForServiceEntity:(ENManagedObject*)serviceEntity;
- (void) save;

@end

#endif
