//
//  ENPreviewManager.h
//  Evernote
//
//  Created by Steve White on 11/8/10.
//  Copyright 2010 Evernote Corporation. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ENPreviewItem.h"
#import "Reachability.h"

@class ENAccountContext;
@class ENCoreDataLocalStore;
@class ENNoteMO;
@class ENPreviewRequest;
@class ENSegmentedDataCache;

extern NSString * const ENPreviewManagerReloadedItemNotification;
extern NSString * const ENPreviewManagerObjectIDKey;
extern NSString * const ENPreviewManagerLocalUUIDKey;
extern NSString * const ENPreviewItemKey;

@interface ENPreviewManager : NSObject

@property (weak, nonatomic, readonly) ENAccountContext *accountContext;
@property (strong, nonatomic) ENSegmentedDataCache *dataCache;
@property (strong, nonatomic) ENCoreDataLocalStore *localStore;
@property (nonatomic, readonly) NetworkStatus networkStatus;

- (id) initWithAccountContext:(ENAccountContext *)accountContext;

// useService: Whether to make a URL request to the service if all necessary data not available locally.
- (ENPreviewItem *) previewItemForNote:(ENNoteMO *)note fetchIfNeeded:(BOOL)fetchIfNeeded useService:(BOOL)useService;
- (ENPreviewItem *) previewItemForNote:(ENNoteMO *)note fetchIfNeeded:(BOOL)fetchIfNeeded;    // useService=YES
- (ENPreviewItem *) previewItemForNote:(ENNoteMO *)note;                                      // useService=YES

- (void) setQueueSuspended:(BOOL)yesOrNo;
- (void) haltQueue;


@end
