//
//  ENSearchStore.h
//  Evernote
//
//  Created by Steve White on 6/19/12.
//  Copyright (c) 2012 Evernote Corporation. All rights reserved.
//

#ifndef ENSearchStore_HEADER_GUARD
#define ENSearchStore_HEADER_GUARD

#import <Foundation/Foundation.h>
#import "ENSearchStoreIndexRequest.h"

@class ENQueryState;

@protocol ENSearchStore <NSObject>

- (void) expungeContentForServiceEntity:(id)serviceEntity;
- (void) expungeContentForServiceEntities:(NSArray *)serviceEntities;

- (BOOL) setSearchContent:(NSString *)searchContent forServiceEntity:(id)serviceEntity;

- (BOOL) processIndexRequests:(NSArray *)indexRequests;

- (BOOL) hasSearchContentForServiceEntity:(id)serviceEntity;
- (NSString *) searchContentForServiceEntity:(id)serviceEntity;
- (id) notesMatchingQueryState:(ENQueryState *)queryState;
- (void) save;

@end


#endif
