//
//  ENSyncOperation.h
//  MacCoreNote
//
//  Created by Steve White on 6/16/12.
//  Copyright (c) 2012 Evernote Corporation. All rights reserved.
//

#import <Foundation/Foundation.h>

@class ENSyncEngine;

typedef enum {
  // This operation will process after sync is complete
  ENSyncOperationPriorityLow = 0,

  // This operation will process before sync starts
  ENSyncOperationPriorityMedium,

  // If sync is in progress, it will be cancelled and restarted
  // to process this operation.
  ENSyncOperationPriorityHigh,
} ENSyncOperationPriority;

@interface ENSyncOperation : NSObject<NSCoding>

@property (assign, nonatomic) ENSyncOperationPriority priority;
@property (strong, nonatomic) ENSyncEngine *syncEngine;

- (BOOL) processOperation;

@end
