//
//  ENXMLDTD.h
//  CoreNote
//
//  Created by Steve White on 10/24/11.
//  Copyright (c) 2011 Evernote Corporation. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <libxml/tree.h>

@interface ENXMLDTD : NSObject

@property ( strong, nonatomic) NSString *docTypeDeclaration;

+ (ENXMLDTD *) enexDTD;
+ (ENXMLDTD *) enex3DTD;
+ (ENXMLDTD *) enml2dtd;
+ (ENXMLDTD *) lat1DTD;
+ (ENXMLDTD *) symbolDTD;
+ (ENXMLDTD *) specialDTD;


- (id) initWithContentsOfFile:(NSString *)file;

- (xmlEntityPtr) xmlEntityNamed:(NSString *)name;
- (xmlElementPtr) xmlElementNamed:(NSString *)name;

- (BOOL) isElementLegal:(NSString *)name;
- (NSDictionary*) sanitizedAttributes:(NSDictionary*)attribDict
                           forElement:(NSString *)elementName;
- (BOOL) isAttributeLegal:(NSString *)attribute 
                inElement:(NSString *)element;
@end
