// From http://www.cocoadev.com/index.pl?CSRegex
// License: Public Domain

#import <Foundation/Foundation.h>
#import <regex.h>

extern NSString * const CSRegexGUIDPattern;

@interface CSRegex:NSObject
{
regex_t preg;
}

-(id)initWithPattern:(NSString *)pattern options:(int)options;
-(void)dealloc;

-(BOOL)matchesString:(NSString *)string;
-(NSString *)matchedSubstringOfString:(NSString *)string;
- (NSArray *) matchedSubstringsOfString: (NSString *) string; // geech
-(NSArray *)capturedSubstringsOfString:(NSString *)string;
- (NSString *) stringByReplacingOccurrencesOfPatternInString:(NSString *)inString withString:(NSString *)replacement; //swhite

+(CSRegex *)regexWithPattern:(NSString *)pattern options:(int)options;
+(CSRegex *)regexWithPattern:(NSString *)pattern;

+(NSString *)null;

+(void)initialize;

@end

@interface NSString (CSRegex)

-(BOOL)matchedByPattern:(NSString *)pattern options:(int)options;
-(BOOL)matchedByPattern:(NSString *)pattern;

-(NSString *)substringMatchedByPattern:(NSString *)pattern options:(int)options;
-(NSString *)substringMatchedByPattern:(NSString *)pattern;

- (NSArray *) substringsMatchedByPattern:(NSString *)pattern options:(int)options;
- (NSArray *) substringsMatchedByPattern:(NSString *)pattern;

-(NSArray *)substringsCapturedByPattern:(NSString *)pattern options:(int)options;
-(NSArray *)substringsCapturedByPattern:(NSString *)pattern;

-(NSString *)escapedPattern;
- (NSString *) stringByReplacingOccurrencesOfPattern:(NSString *)pattern withString:(NSString *)replacement; //swhite
- (NSString *) stringByCompressingWhitespace; // swhite
- (NSString *) stringWithRightTrim; // swhite
@end
