//
//  ENHelperIPCServerProtocol.h
//  EvernoteHelper
//
//  Created by Ruben Bakker on 2/11/13.
//

#import <Foundation/Foundation.h>

@protocol ENHelperIPCServerProtocol

/**
 * Update the Evernote Helper's preferences with the given key-value pairs.
 * Only those preferences keys relevant to the Evernote Helper are retained.
 */
- (void)updatePreferences:(NSDictionary *)data;


/**
 * The main app has changed account info. 
 * Keys for ENAnalyticsAccountInfoProvider.
 *   - kENAnalyticsAccountInfo_Type         string
 *   - kENAnalyticsAccountInfo_userID       string
 *   - kENAnalyticsAccountInfo_serviceHost  string
 *   - kENAnalyticsAccountInfo_version      string
 *   - kENAnalyticsAccountInfo_shortVersion string
 * Keys for General Account Info (For ENAppDelegate - Helper)
 *   - kENAccountInfo_businessID            number
 *   - kENAccountInfo_accountAge            date
 *   - kENAccountInfo_loginID               string
 *   - kENAccountInfo_isPremium             NSNumber bool
 */
- (void)accountInfoDidChange:(NSDictionary *)accountInfo;


/**
 * Get the version string of the Evernote helper application.
 * @return CFBundleVersion of the helper app.
 */
- (NSString *)helperVersion;


@end
