//
//  ENPool.h
//  ENSharedUtilities
//
//  Created by Andrew McGeachie on 2/28/14.
//  Copyright (c) 2014 Evernote. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef id (^ENPoolCreationBlock)();


@interface ENPool : NSObject


@property (copy) ENPoolCreationBlock creationBlock;


/**
 * Take an object from the pool.  Thread safe.
 * A new instance will be created if there are not enough objects
 * already in the pool.
 * Caller should not release this object.
 */
- (id) takeObject;


/**
 * Return an object to the pool.
 * Thanks for sharing!
 */
- (void) returnObject: (id) object;


@end
