//
//  NSURL+ENSharedUtilities.h
//  EverNote
//
//  Created by Andrew McGeachie on 6/3/08.
//  Copyright 2008-2012 Evernote, Corp. All rights reserved.
//

#ifndef ENSharedUtilities_NSURL_EvernoteMac
#define ENSharedUtilities_NSURL_EvernoteMac

#import <Cocoa/Cocoa.h>


@interface NSURL (ENSharedUtilities)

/**
 * Get a string of the form "{host}…"
 */
- (NSString *) veryShortDisplayText;


/**
 * Fetch the data at this HTTP[S] URL and log unexpected occurences.
 * Ignores local caches.
 */
- (NSData *) fetchDataWithLogging;


/**
 * Returns an Evernote-specific URL for a stack.
 */
+ (NSURL *)URLWithStackName:(NSString *)stackName;


/**
 * Converts an Evernote stack URL back to a stack name.
 * Returns nil if the URL is not an Evernote stack URL.
 */
- (NSString *)stackName;


@end

#endif
