//
//  ENPhoneNumberFormatter.h
//  TestPhoneNumberAutoFormat
//
//  Created by Tong Liu on 12/12/11.
//  Copyright (c) 2011 Evernote. All rights reserved.
//

#import <Foundation/Foundation.h>

#if TARGET_OS_IPHONE
#import <UIKit/UIKit.h>
#define AddTextFieldToPhoneNumberFormatter(observer, obj) [[NSNotificationCenter defaultCenter] addObserver:observer selector:@selector(phoneNumberTextFieldTextDidChange:) name:UITextFieldTextDidChangeNotification object:obj]
#define RemoveTextFieldFromPhoneNumberFormatter(observer, obj) [[NSNotificationCenter defaultCenter] removeObserver:observer name:UITextFieldTextDidChangeNotification object:obj];
#endif

@interface ENPhoneNumberFormatter : NSObject

+ (ENPhoneNumberFormatter *)sharedFormatter;
- (void)reset;
- (NSString *)formattedPhoneNumberFromPhoneNumber:(NSString *)number;
- (NSString *)countryCodeFromPhoneNumberPrefix:(NSString *)prefix;

@end
